<?php

/**
 * This is the model class for table "users".
 *
 * The followings are the available columns in table 'users':
 * @property integer $id
 * @property string $username
 * @property string $pwd
 * @property integer $role_id
 * @property string $firstname
 * @property string $lastname
 * @property string $phoneno
 * @property string $email
 * @property string $address1
 * @property string $address2
 * @property integer $zipcode_id
 * @property integer $state_id
 * @property integer $city_id
 * @property integer $country_id
 */
class User extends CActiveRecord
{
	public $tos; 

	/**
	 * @return string the associated database table name
	 */
	public function tableName()
	{
		return 'customer';
	}
	public function rules() { 
		return array(array ( "address1, firstname" , "safe" ) 
		); 
	} 
	/**
	 * @return array relational rules.
	 */
	public function relations()
	{
		// NOTE: you may need to adjust the relation name and the related
		// class name for the relations automatically generated below.
		return array(
				'countrydata'=>array(self::BELONGS_TO, 'Countries', 'country'),
			   'statedata'=>array(self::BELONGS_TO, 'State', 'state'),
			   'customer_number'=>array(self::HAS_MANY, 'CustomerNumber', 'customerId'),
			   'customer_invoice'=>array(self::HAS_MANY, 'CustomernewInvoices', 'customer_id'),
			   'customer_transactions'=>array(self::HAS_MANY, 'Transactions', 'customer_id'),
		);
	}

	/**
	 * Returns the static model of the specified AR class.
	 * Please note that you should have this exact method in all your CActiveRecord descendants!
	 * @param string $className active record class name.
	 * @return Users the static model class
	 */
	public static function model($className=__CLASS__)
	{
		return parent::model($className);
	}	
	// hash password
	public function hashPassword($password)
	{
		return md5($password);
	}
			
	// password validation
	public function validatePassword($password)
	{
		return $this->hashPassword($password)===$this->userpassword;
	}
			
	//generate salt
	/*public function generateSalt()
	{
		return uniqid('',true);
	}
			
	public function beforeValidate()
	{
		$this->salt = $this->generateSalt();
		return parent::beforeValidate();
	}*/
			
	public function beforeSave()
	{
		if ($this->isNewRecord) 
		$this->userpassword = $this->hashPassword($this->userpassword);
		return parent::beforeSave();
	}

}
